
import QtQuick 1.0
import Physics 1.0 as Physics

Rectangle {
    id : window
    width: 800
    height: 480

    // There must be a world.
    Physics.World2D {
        id : world
        gravity : Qt.vector3d(0, 9.81, 0)

        // Good delta for 2D animations
        timeDelta : 0.1
    }

    // Green ball with the intention to fall all the way down
    Rectangle {
        id : ball
        y : 10
        x : 400
        width : 50
        height : width
        radius : width / 2
        color : "green"
        smooth : true
        transform : Physics.Body2D
        {
            target : ball
            objectName: "The Amazing Ball"
            shape   : Physics.Body2D.ShapeSphere
            linearVelocity.x : 5
            mass    : 1
            // Some bouncyness
            restitution : .4
            friction : 0.4

        }
        Rectangle {
            x : 10
            y : 10
            color : "black"
            width : 5
            height : 5
            radius: width / 2
        }
    }


    // But the ball... will face resistance
    Rectangle {
        y : 400
        id : floor
        color : "black"
        width : 800
        height : 50
        radius : 5
        transform : Physics.Body2D {
            target : floor

            mass : 0
            shape : Physics.Body2D.ShapeBox
            friction : 1
            restitution : 0.5

            collisionEventEnabled: true
            onCollision: {
                console.log("Oh my! I was hit by " + collision.body.objectName);
                console.log("With crushing force of " + collision.force + " kilonewtons!");
                collision.accepted = true
            }
        }
    }
}
